> For a complete documentation index, fetch https://docs.voximplant.ai/llms.txt # GetTransactionHistoryAsync POST https://api.voximplant.com/platform_api/GetTransactionHistoryAsync The [GetTransactionHistory] asynchronous implementation. Use this function to download a large amounts of data. Take a look at the [GetHistoryReports] and [DownloadHistoryReport] functions for downloading details. Allowed roles: `Owner`, `Admin`, `Accountant`, `Payer`. **Example request:** Get the three transactions record from the 2012-01-01 00:00:00 UTC to the 2014-01-01 00:00:00 UTC with the 'gift' or 'money_distribution' types. Reference: https://docs.voximplant.ai/api-reference/management-api/reference/history/get-transaction-history-async ## Authentication - `Authorization` header (bearer token, required) — Voximplant Management API uses signed JWT tokens generated from your service-account private key. Pass the token in the `Authorization` header as a Bearer value: ``` Authorization: Bearer $VOXIMPLANT_TOKEN ``` See [Authorization](/api-reference/management-api/authorization) for ready-to-copy snippets in bash, Python, Node.js and Go that turn your `credentials.json` into a token. ## Request ### Query parameters - `from_date` (string, required) — The from date in the selected timezone in 24-h format: YYYY-MM-DD HH:mm:ss - `to_date` (string, required) — The to date in the selected timezone in 24-h format: YYYY-MM-DD HH:mm:ss - `transaction_id` (list of integer, optional) — The transaction ID list separated by semicolons (;) - `transaction_type` (list of string, optional) — The transaction type list separated by semicolons (;). The following values are possible: gift_revoke, resource_charge, money_distribution, subscription_charge, subscription_installation_charge, card_periodic_payment, card_overrun_payment, card_payment, rub_card_periodic_payment, rub_card_overrun_payment, rub_card_payment, robokassa_payment, gift, promo, adjustment, wire_transfer, us_wire_transfer, refund, discount, mgp_charge, mgp_startup, mgp_business, mgp_big_business, mgp_enterprise, mgp_large_enterprise, techsupport_charge, tax_charge, monthly_fee_charge, grace_credit_payment, grace_credit_provision, mau_charge, mau_overrun, im_charge, im_overrun, fmc_charge, sip_registration_charge, development_fee, money_transfer_to_child, money_transfer_to_parent, money_acceptance_from_child, money_acceptance_from_parent, phone_number_installation, phone_number_charge, toll_free_phone_number_installation, toll_free_phone_number_charge, services, user_money_transfer, paypal_payment, paypal_overrun_payment, paypal_periodic_payment - `user_id` (list of integer, optional) — The user ID list separated by semicolons (;) - `child_account_id` (list of integer, optional) — The child account ID list separated by semicolons (;). Use the 'all' value to select all child accounts - `children_transactions_only` (boolean, optional, default: false) — Whether to get the children account transactions only - `users_transactions_only` (boolean, optional, default: false) — Whether to get the users' transactions only - `desc_order` (boolean, optional) — Whether to get records in the descent order - `is_uncommitted` (boolean, optional, default: false) — Whether to get transactions on hold (transactions for which money is reserved but not yet withdrawn from the account) - `with_header` (boolean, optional, default: true) — Whether to get a CSV file with the column names if the output=csv - `output` (string, optional, default: csv) — The output format. The following values available: **csv**. The default value is **csv** ## Response ### 200 Successful response - `result` (integer, optional) — Returns 1 if the request has been completed successfully - `history_report_id` (integer, optional) — The history report ID ## Examples **Request** ```json {} ``` **Response** ```json { "result": 1, "history_report_id": 13 } ``` **SDK Code** ```python Example 1 import requests url = "https://api.voximplant.com/platform_api/GetTransactionHistoryAsync" querystring = {"from_date":"2012-01-01 00:00:00","to_date":"2014-01-01 00:00:00","transaction_type":"[\"gift\",\"money_distribution\"]"} payload = {} headers = { "Authorization": "Bearer ", "Content-Type": "application/json" } response = requests.post(url, json=payload, headers=headers, params=querystring) print(response.json()) ``` ```javascript Example 1 const url = 'https://api.voximplant.com/platform_api/GetTransactionHistoryAsync?from_date=2012-01-01+00%3A00%3A00&to_date=2014-01-01+00%3A00%3A00&transaction_type=%5B%22gift%22%2C%22money_distribution%22%5D'; const options = { method: 'POST', headers: {Authorization: 'Bearer ', 'Content-Type': 'application/json'}, body: '{}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go Example 1 package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://api.voximplant.com/platform_api/GetTransactionHistoryAsync?from_date=2012-01-01+00%3A00%3A00&to_date=2014-01-01+00%3A00%3A00&transaction_type=%5B%22gift%22%2C%22money_distribution%22%5D" payload := strings.NewReader("{}") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("Authorization", "Bearer ") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby Example 1 require 'uri' require 'net/http' url = URI("https://api.voximplant.com/platform_api/GetTransactionHistoryAsync?from_date=2012-01-01+00%3A00%3A00&to_date=2014-01-01+00%3A00%3A00&transaction_type=%5B%22gift%22%2C%22money_distribution%22%5D") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Authorization"] = 'Bearer ' request["Content-Type"] = 'application/json' request.body = "{}" response = http.request(request) puts response.read_body ``` ```java Example 1 import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://api.voximplant.com/platform_api/GetTransactionHistoryAsync?from_date=2012-01-01+00%3A00%3A00&to_date=2014-01-01+00%3A00%3A00&transaction_type=%5B%22gift%22%2C%22money_distribution%22%5D") .header("Authorization", "Bearer ") .header("Content-Type", "application/json") .body("{}") .asString(); ``` ```php Example 1 request('POST', 'https://api.voximplant.com/platform_api/GetTransactionHistoryAsync?from_date=2012-01-01+00%3A00%3A00&to_date=2014-01-01+00%3A00%3A00&transaction_type=%5B%22gift%22%2C%22money_distribution%22%5D', [ 'body' => '{}', 'headers' => [ 'Authorization' => 'Bearer ', 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp Example 1 using RestSharp; var client = new RestClient("https://api.voximplant.com/platform_api/GetTransactionHistoryAsync?from_date=2012-01-01+00%3A00%3A00&to_date=2014-01-01+00%3A00%3A00&transaction_type=%5B%22gift%22%2C%22money_distribution%22%5D"); var request = new RestRequest(Method.POST); request.AddHeader("Authorization", "Bearer "); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift Example 1 import Foundation let headers = [ "Authorization": "Bearer ", "Content-Type": "application/json" ] let parameters = [] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://api.voximplant.com/platform_api/GetTransactionHistoryAsync?from_date=2012-01-01+00%3A00%3A00&to_date=2014-01-01+00%3A00%3A00&transaction_type=%5B%22gift%22%2C%22money_distribution%22%5D")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```